/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Mon Dec  1 18:57:49 2014.
 *
 * -----------------------------------------------------------------------
 *
 * 
 * Copyright Ericsson AB 2014. All Rights Reserved.
 * 
 * The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved online at http://www.erlang.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_ETS (7)
#define ERTS_ALC_A_FIXED_SIZE (8)
#define ERTS_ALC_A_BINARY (9)
#define ERTS_ALC_A_DRIVER (10)

#define ERTS_ALC_A_MAX (10)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_ATOM  (1)
#define ERTS_ALC_C_BINARIES  (2)
#define ERTS_ALC_C_SYSTEM  (3)
#define ERTS_ALC_C_PROCESSES  (4)
#define ERTS_ALC_C_CODE  (5)
#define ERTS_ALC_C_ETS  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (5)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (6)
#define ERTS_ALC_N_MAX_A_TEMPORARY (24)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (25)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (56)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (57)
#define ERTS_ALC_N_MAX_A_STANDARD (91)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (92)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (131)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (132)
#define ERTS_ALC_N_MAX_A_EHEAP (135)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (136)
#define ERTS_ALC_N_MAX_A_ETS (144)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (145)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (150)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (151)
#define ERTS_ALC_N_MAX_A_BINARY (152)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (153)
#define ERTS_ALC_N_MAX_A_DRIVER (170)

#define ERTS_ALC_N_MAX (170)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (177)
#define ERTS_ALC_T_NBIF_TABLE (305)
#define ERTS_ALC_T_INFO_DSBUF (433)
#define ERTS_ALC_T_HIPE (561)
#define ERTS_ALC_T_PUTENV_STR (689)
#define ERTS_ALC_T_TMP_HEAP (834)
#define ERTS_ALC_T_MSG_ROOTS (962)
#define ERTS_ALC_T_ROOTSET (1090)
#define ERTS_ALC_T_LOADER_TMP (1234)
#define ERTS_ALC_T_NC_TMP (1330)
#define ERTS_ALC_T_TMP (1458)
#define ERTS_ALC_T_DCTRL_BUF (1586)
#define ERTS_ALC_T_TMP_DIST_BUF (1714)
#define ERTS_ALC_T_ESTACK (1842)
#define ERTS_ALC_T_DB_TMP (2018)
#define ERTS_ALC_T_DB_MC_STK (2146)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2274)
#define ERTS_ALC_T_LOGGER_DSBUF (2354)
#define ERTS_ALC_T_TMP_DSBUF (2482)
#define ERTS_ALC_T_DDLL_TMP_BUF (2610)
#define ERTS_ALC_T_RE_TMP_BUF (2738)
#define ERTS_ALC_T_TEMP_TERM (2866)
#define ERTS_ALC_T_SYS_READ_BUF (2994)
#define ERTS_ALC_T_ENVIRONMENT (3122)
#define ERTS_ALC_T_PEND_SUSPEND (3267)
#define ERTS_ALC_T_PROC_LIST (3395)
#define ERTS_ALC_T_EXTRA_ROOT (3523)
#define ERTS_ALC_T_PREPARED_CODE (3667)
#define ERTS_ALC_T_SL_BIF_TIMER (3779)
#define ERTS_ALC_T_DB_FIXATION (3939)
#define ERTS_ALC_T_DB_FIX_DEL (4067)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4195)
#define ERTS_ALC_T_DB_PROC_CLEANUP (4323)
#define ERTS_ALC_T_PORT_TASK (4403)
#define ERTS_ALC_T_PT_HNDL_LIST (4531)
#define ERTS_ALC_T_MISC_OP_LIST (4659)
#define ERTS_ALC_T_PORT_NAMES (4787)
#define ERTS_ALC_T_PTAB_LIST_DEL (4931)
#define ERTS_ALC_T_PTAB_LIST_CNKI (5059)
#define ERTS_ALC_T_PTAB_LIST_PIDS (5187)
#define ERTS_ALC_T_RE_SUBJECT (5299)
#define ERTS_ALC_T_RE_STACK (5427)
#define ERTS_ALC_T_UNICODE_BUFFER (5555)
#define ERTS_ALC_T_BINARY_BUFFER (5683)
#define ERTS_ALC_T_TMP_CPU_IDS (5811)
#define ERTS_ALC_T_EXT_TERM_DATA (5955)
#define ERTS_ALC_T_CODE_IX_LOCK_Q (6067)
#define ERTS_ALC_T_BUSY_CALLER_TAB (6195)
#define ERTS_ALC_T_BUSY_CALLER (6323)
#define ERTS_ALC_T_THR_Q_SL (6451)
#define ERTS_ALC_T_ETHR_SL (6579)
#define ERTS_ALC_T_AINFO_REQ (6707)
#define ERTS_ALC_T_SCHED_WTIME_REQ (6835)
#define ERTS_ALC_T_GC_INFO_REQ (6963)
#define ERTS_ALC_T_FD_LIST (7091)
#define ERTS_ALC_T_POLLSET_UPDREQ (7219)
#define ERTS_ALC_T_REG_PROC (7364)
#define ERTS_ALC_T_LINK_LH (7492)
#define ERTS_ALC_T_SUSPEND_MON (7620)
#define ERTS_ALC_T_LL_BIF_TIMER (7748)
#define ERTS_ALC_T_REG_TABLE (7860)
#define ERTS_ALC_T_FUN_TABLE (8020)
#define ERTS_ALC_T_DIST_TABLE (8116)
#define ERTS_ALC_T_NODE_TABLE (8244)
#define ERTS_ALC_T_MODULE_REFS (8404)
#define ERTS_ALC_T_DCACHE (8500)
#define ERTS_ALC_T_DIST_ENTRY (8628)
#define ERTS_ALC_T_NODE_ENTRY (8756)
#define ERTS_ALC_T_ARG_REG (8900)
#define ERTS_ALC_T_PROC_DICT (9028)
#define ERTS_ALC_T_CALLS_BUF (9156)
#define ERTS_ALC_T_BPD (9268)
#define ERTS_ALC_T_LINEBUF (9396)
#define ERTS_ALC_T_IOQ (9524)
#define ERTS_ALC_T_BITS_BUF (9652)
#define ERTS_ALC_T_DB_NTAB_ENT (9828)
#define ERTS_ALC_T_DDLL_HANDLE (9908)
#define ERTS_ALC_T_NODES_MON (10052)
#define ERTS_ALC_T_RE_HEAP (10164)
#define ERTS_ALC_T_PSD (10308)
#define ERTS_ALC_T_PRTSD (10420)
#define ERTS_ALC_T_ZLIB (10548)
#define ERTS_ALC_T_PORT_DATA_HEAP (10676)
#define ERTS_ALC_T_THR_Q (10804)
#define ERTS_ALC_T_ETHR_STD (10932)
#define ERTS_ALC_T_DDLL_PROCESS (11060)
#define ERTS_ALC_T_MONITOR_LH (11204)
#define ERTS_ALC_T_NLINK_LH (11332)
#define ERTS_ALC_T_DB_HEIR_DATA (11492)
#define ERTS_ALC_T_FD_ENTRY_BUF (11572)
#define ERTS_ALC_T_PRT_REP_EXIT (11700)
#define ERTS_ALC_T_ATOM (11797)
#define ERTS_ALC_T_MODULE (11989)
#define ERTS_ALC_T_FUN_ENTRY (12117)
#define ERTS_ALC_T_ATOM_TXT (12181)
#define ERTS_ALC_T_BIF_TIMER_TABLE (12341)
#define ERTS_ALC_T_ATOM_TABLE (12437)
#define ERTS_ALC_T_EXPORT_TABLE (12629)
#define ERTS_ALC_T_MODULE_TABLE (12757)
#define ERTS_ALC_T_TAINT (12885)
#define ERTS_ALC_T_PROC_TABLE (12997)
#define ERTS_ALC_T_PORT_TABLE (13109)
#define ERTS_ALC_T_TIMER_WHEEL (13237)
#define ERTS_ALC_T_ASYNC_DATA (13365)
#define ERTS_ALC_T_DB_TABLES (13541)
#define ERTS_ALC_T_INSTR_INFO (13621)
#define ERTS_ALC_T_SCHDLR_SLP_INFO (13749)
#define ERTS_ALC_T_RUNQS (13877)
#define ERTS_ALC_T_DDLL_ERRCODES (14005)
#define ERTS_ALC_T_PRE_ALLOC_DATA (14133)
#define ERTS_ALC_T_CPUDATA (14261)
#define ERTS_ALC_T_CPU_GRPS_MAP (14389)
#define ERTS_ALC_T_AUX_WORK_TMO (14517)
#define ERTS_ALC_T_MISC_AUX_WORK_Q (14645)
#define ERTS_ALC_T_PROC_INTERVAL (14773)
#define ERTS_ALC_T_THR_Q_LL (14901)
#define ERTS_ALC_T_ETHR_LL (15029)
#define ERTS_ALC_T_CODE (15189)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (15333)
#define ERTS_ALC_T_SCHDLR_DATA (15413)
#define ERTS_ALC_T_LL_TEMP_TERM (15541)
#define ERTS_ALC_T_EXPORT (15701)
#define ERTS_ALC_T_DRV_TAB (15797)
#define ERTS_ALC_T_DRV_EV_STATE (15925)
#define ERTS_ALC_T_POLLSET (16053)
#define ERTS_ALC_T_POLL_FDS (16181)
#define ERTS_ALC_T_POLL_RES_EVS (16309)
#define ERTS_ALC_T_FD_STATUS (16437)
#define ERTS_ALC_T_SELECT_FDS (16565)
#define ERTS_ALC_T_FD_TAB (16693)
#define ERTS_ALC_T_CS_PROG_PATH (16821)
#define ERTS_ALC_T_BEAM_REGISTER (16966)
#define ERTS_ALC_T_HEAP (17094)
#define ERTS_ALC_T_OLD_HEAP (17222)
#define ERTS_ALC_T_HEAP_FRAG (17350)
#define ERTS_ALC_T_DB_TABLE (17511)
#define ERTS_ALC_T_DB_SEG (17639)
#define ERTS_ALC_T_DB_SEG_TAB (17767)
#define ERTS_ALC_T_DB_STK (17895)
#define ERTS_ALC_T_DB_TRANS_TAB (18023)
#define ERTS_ALC_T_DB_SEL_LIST (18151)
#define ERTS_ALC_T_DB_DMC_ERROR (18279)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (18407)
#define ERTS_ALC_T_DB_TERM (18535)
#define ERTS_ALC_T_PROC (18632)
#define ERTS_ALC_T_MSG_REF (18760)
#define ERTS_ALC_T_MONITOR_SH (18888)
#define ERTS_ALC_T_NLINK_SH (19016)
#define ERTS_ALC_T_DRV_EV_D_STATE (19128)
#define ERTS_ALC_T_DRV_SEL_D_STATE (19256)
#define ERTS_ALC_T_DRV_BINARY (19369)
#define ERTS_ALC_T_BINARY (19497)
#define ERTS_ALC_T_PORT (19642)
#define ERTS_ALC_T_DRV (19770)
#define ERTS_ALC_T_DRIVER (19898)
#define ERTS_ALC_T_DRV_CMD_DATA (20026)
#define ERTS_ALC_T_DRV_CTRL_DATA (20154)
#define ERTS_ALC_T_DRV_CALL_DATA (20282)
#define ERTS_ALC_T_NIF (20410)
#define ERTS_ALC_T_PORT_DATA_LOCK (20538)
#define ERTS_ALC_T_DRV_THR_OPTS (20666)
#define ERTS_ALC_T_DRV_TID (20794)
#define ERTS_ALC_T_DRV_MTX (20922)
#define ERTS_ALC_T_DRV_CND (21050)
#define ERTS_ALC_T_DRV_RWLCK (21178)
#define ERTS_ALC_T_DRV_TSD (21306)
#define ERTS_ALC_T_THR_Q_EL (21434)
#define ERTS_ALC_T_THR_Q_EL_SL (21562)
#define ERTS_ALC_T_MISC_AUX_WORK (21690)
#define ERTS_ALC_T_ASYNC (21818)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_HIPE,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_TMP_HEAP,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_RE_TMP_BUF,
  ERTS_ALC_T_TEMP_TERM,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_EXTRA_ROOT,
  ERTS_ALC_T_PREPARED_CODE,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_DB_PROC_CLEANUP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PT_HNDL_LIST,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_PTAB_LIST_DEL,
  ERTS_ALC_T_PTAB_LIST_CNKI,
  ERTS_ALC_T_PTAB_LIST_PIDS,
  ERTS_ALC_T_RE_SUBJECT,
  ERTS_ALC_T_RE_STACK,
  ERTS_ALC_T_UNICODE_BUFFER,
  ERTS_ALC_T_BINARY_BUFFER,
  ERTS_ALC_T_TMP_CPU_IDS,
  ERTS_ALC_T_EXT_TERM_DATA,
  ERTS_ALC_T_CODE_IX_LOCK_Q,
  ERTS_ALC_T_BUSY_CALLER_TAB,
  ERTS_ALC_T_BUSY_CALLER,
  ERTS_ALC_T_THR_Q_SL,
  ERTS_ALC_T_ETHR_SL,
  ERTS_ALC_T_AINFO_REQ,
  ERTS_ALC_T_SCHED_WTIME_REQ,
  ERTS_ALC_T_GC_INFO_REQ,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DB_NTAB_ENT,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_RE_HEAP,
  ERTS_ALC_T_PSD,
  ERTS_ALC_T_PRTSD,
  ERTS_ALC_T_ZLIB,
  ERTS_ALC_T_PORT_DATA_HEAP,
  ERTS_ALC_T_THR_Q,
  ERTS_ALC_T_ETHR_STD,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_DB_HEIR_DATA,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_TAINT,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_ASYNC_DATA,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_SLP_INFO,
  ERTS_ALC_T_RUNQS,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PRE_ALLOC_DATA,
  ERTS_ALC_T_CPUDATA,
  ERTS_ALC_T_CPU_GRPS_MAP,
  ERTS_ALC_T_AUX_WORK_TMO,
  ERTS_ALC_T_MISC_AUX_WORK_Q,
  ERTS_ALC_T_PROC_INTERVAL,
  ERTS_ALC_T_THR_Q_LL,
  ERTS_ALC_T_ETHR_LL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_LL_TEMP_TERM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_SELECT_FDS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_BEAM_REGISTER,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_PORT,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_DRIVER,
  ERTS_ALC_T_DRV_CMD_DATA,
  ERTS_ALC_T_DRV_CTRL_DATA,
  ERTS_ALC_T_DRV_CALL_DATA,
  ERTS_ALC_T_NIF,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_THR_Q_EL,
  ERTS_ALC_T_THR_Q_EL_SL,
  ERTS_ALC_T_MISC_AUX_WORK,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "info_dsbuf",
  "hipe_data",
  "putenv_string",
  "tmp_heap",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "re_tmp_buf",
  "temp_term",
  "sys_read_buf",
  "environment",
  "pending_suspend",
  "proc_list",
  "extra_root",
  "prepared_code",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "db_proc_cleanup_state",
  "port_task",
  "port_task_handle_list",
  "misc_op_list",
  "port_names",
  "ptab_list_deleted_el",
  "ptab_list_chunk_info",
  "ptab_list_pids",
  "re_subject",
  "re_stack",
  "unicode_buffer",
  "binary_buffer",
  "tmp_cpu_ids",
  "external_term_data",
  "code_ix_lock_q",
  "busy_caller_table",
  "busy_caller",
  "short_lived_thr_queue",
  "ethread_short_lived",
  "alloc_info_request",
  "sched_wall_time_request",
  "gc_info_request",
  "fd_list",
  "pollset_update_req",
  "reg_proc",
  "link_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "line_buf",
  "io_queue",
  "bits_buf",
  "db_named_table_entry",
  "ddll_handle",
  "nodes_monitor",
  "re_heap",
  "process_specific_data",
  "port_specific_data",
  "zlib",
  "port_data_heap",
  "thr_queue",
  "ethread_standard",
  "ddll_processes",
  "monitor_lh",
  "nlink_lh",
  "db_heir_data",
  "fd_entry_buf",
  "port_report_exit",
  "atom_entry",
  "module_entry",
  "fun_entry",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "taint_list",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "internal_async_data",
  "db_tabs",
  "instr_info",
  "scheduler_sleep_info",
  "run_queues",
  "ddll_errcodes",
  "pre_alloc_data",
  "cpu_data",
  "cpu_groups_map",
  "aux_work_timeouts",
  "misc_aux_work_q",
  "process_interval",
  "long_lived_thr_queue",
  "ethread_long_lived",
  "code",
  "db_match_pseudo_proc",
  "scheduler_data",
  "ll_temp_term",
  "export_entry",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "select_fds",
  "fd_tab",
  "cs_prog_path",
  "beam_register",
  "heap",
  "old_heap",
  "heap_frag",
  "db_tab",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "msg_ref",
  "monitor_sh",
  "nlink_sh",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "port",
  "drv_internal",
  "driver",
  "driver_command_data",
  "driver_control_data",
  "driver_call_data",
  "nif_internal",
  "port_data_lock",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "thr_q_element",
  "sl_thr_q_element",
  "misc_aux_work",
  "async",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "atom_data",
  "binary_data",
  "system_data",
  "process_data",
  "code_data",
  "ets_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
